function write_fir_coeffs( coeff, fname )
%write_fir_coeffs 
%  write filter length and FIR coefficients to C header file   

N=length(coeff);
fid = fopen(fname,'wt');
fprintf(fid,'// %s\n',fname);
fprintf(fid,'// this file was generated using ');
fprintf(fid,'function write_fir_coeffs.m\n');
fprintf(fid,'\nconst int N = %d;\n',N);
fprintf(fid,'\nconst float32_t h[N] = { \n');
% j is used to count coefficients written to current line
% in output file
j=0;
% i is used to count through coefficients
for i=1:N  
% if six coeffs have been written to current line
% then start new line
  if j>5    
    j=0; 
    fprintf(fid,'\n');  
  end  
% if this is the last coefficient then simply write
% its value to the current line
% else write coefficient value, followed by comma
  if i==N
   fprintf(fid,'%2.8E',coeff(i));
  else
    fprintf(fid,'%2.8E,',coeff(i));  
    j=j+1;
  end
end
fprintf(fid,'\n};\n');
fclose(fid);          

end

