// average_intr.c 

#include "audio.h"

void I2S_HANDLER(void) {  /****** I2S Interruption Handler *****/
	const int N = 5;
	const float32_t b[N] = {0.2, 0.2, 0.2, 0.2, 0.2};
	static float32_t x[N];
  int16_t audio_chR=0;    //16 bits audio data channel right
  int16_t audio_chL=0;    //16 bits audio data channel left

  float32_t yn = 0.0;
	int16_t k = 0;
	
  audio_IN = i2s_rx();	
  audio_chR = audio_IN & 0x0000FFFF;          //separate 16 bits channel left
  audio_chL = (audio_IN >>16) & 0x0000FFFF;   //separate 16 bits channel right

	x[0] = (float32_t) audio_chL;  // new sample is element 0 in array
	for(k = 0; k<N; k++)
	{
		yn += b[k]*x[k];  // calculate filter output
	}
	
	for(k = N-1; k>0; k--)  // shift sample stack down for next call to ISR
	{
		x[k] = x[k-1];
	}
	
 	audio_chL= (int16_t) yn;
  audio_OUT = (audio_chL <<16 & 0xFFFF0000) | (audio_chR & 0x0000FFFF);	//put the two channels toguether again
  i2s_tx(audio_OUT);
}

int main(void)
{
  audio_init(hz8000, line_in, intr, I2S_HANDLER); 
  while(1){}
}
