// fir_intr.c 

#include "audio.h"
#include "ma_5pt.h"	 //from "write_fir_coeffs.m"

void I2S_HANDLER(void) {                  
  int16_t audio_chR=0;    
  int16_t audio_chL=0;
  static float32_t x[N];
  float32_t yn = 0.0;
  int k;
	
	gpio_set(P10, HIGH);	// write GPIO high to mark start of ISR
	
  audio_IN = i2s_rx();	
	audio_chR = (audio_IN & 0x0000FFFF);       
	audio_chL = ((audio_IN >>16)& 0x0000FFFF); 
	
	x[0] = (float32_t) audio_chL;	// new sample is element 0 in array
	
	for(k = 0; k<N; k++) // calculate filter output
	{
		yn += h[k]*x[k];		
	}
	for(k = N-1; k>0; k--) // shift sample stack down for next call to ISR
	{
		x[k] = x[k-1];
	}

	audio_chL = (int16_t) yn; // filter output to left channel
  audio_OUT = ((audio_chL <<16 & 0xFFFF0000)) + (audio_chR & 0x0000FFFF);	
  i2s_tx(audio_OUT);
	gpio_set(P10, LOW); 	// write GPIO low to mark end of ISR
}

int main(void)
{
  gpio_set_mode(P10, Output);  // configure GPIO for output
  audio_init(hz48000, line_in, intr, I2S_HANDLER); 
  while(1){}
}
