// sine_lut_intr.c

#include "audio.h"
 
void I2S_HANDLER(void) {    /****** I2S Interruption Handler*****/
	const int loop_size = 8;
	const int16_t sine_table[loop_size] = {0, 7071, 10000, 7071, 0, -7071, -10000, -7071};
	static int sine_ptr = 0;

	int16_t audio_chR=0;    
  int16_t audio_chL=0;

	audio_IN = i2s_rx();	
  audio_chR = (audio_IN & 0x0000FFFF);       
  audio_chL = ((audio_IN >>16)& 0x0000FFFF); 

  audio_chL = sine_table[sine_ptr];
	audio_chR = sine_table[sine_ptr];
  sine_ptr = (sine_ptr+1) % loop_size;
	
  audio_OUT = ((audio_chL<<16) & 0xFFFF0000) | (audio_chR & 0x0000FFFF);	
  i2s_tx(audio_OUT);
}

int main(void) {
  audio_init(hz8000, line_in, intr, I2S_HANDLER); 
  while(1){}
}
